unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls, Vcl.Imaging.jpeg, Vcl.Imaging.pngimage;

type
  TForm2 = class(TForm)
    BtnTest1: TButton;
    Image1: TImage;
    BtnTest2: TButton;
    BtnTest3: TButton;
    BtnTest4: TButton;
    procedure BtnTest1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form2: TForm2;

implementation

{$R *.dfm}

uses Imaging, ImagingClasses, ImagingTypes, ImagingCanvases, ImagingComponents, ImagingUtility;

procedure TForm2.BtnTest1Click(Sender: TObject);
var
  CanvasMain, CanvasWater: TImagingCanvas;
  MainImage, Watermark: TSingleImage;
  R: TRect;
begin
  if Tbutton(Sender).Caption='Test 1' then MainImage := TSingleImage.CreateFromFile('aar.png')
  else if Tbutton(Sender).Caption='Test 2' then MainImage := TSingleImage.CreateFromFile('aar.png')
  else if Tbutton(Sender).Caption='Test 3' then MainImage := TSingleImage.CreateFromFile('aaralpha.png')
  else if Tbutton(Sender).Caption='Test 4' then MainImage := TSingleImage.CreateFromFile('aaralpha.png');

  CanvasMain := TImagingCanvas.CreateForImage(MainImage);

  if Tbutton(Sender).Caption='Test 1' then Watermark := TSingleImage.CreateFromFile('act.png')
  else if Tbutton(Sender).Caption='Test 2' then Watermark := TSingleImage.CreateFromFile('Arial12Shadow.dds')
  else if Tbutton(Sender).Caption='Test 3' then Watermark := TSingleImage.CreateFromFile('act.png')
  else if Tbutton(Sender).Caption='Test 4' then Watermark := TSingleImage.CreateFromFile('Arial12Shadow.dds');

  CanvasWater := TImagingCanvas.CreateForImage(Watermark);

  Image1.Picture.Bitmap := TImagingBitmap.Create;

  R := Rect(0, 0, MainImage.Width, MainImage.Height);
  R := ScaleRectToRect(Watermark.BoundsRect, R);

  CanvasWater.StretchDrawAlpha(Watermark.BoundsRect, CanvasMain, R);

  Image1.Picture.Graphic.Assign(MainImage);
end;

end.
